#include "../snes9x/snes9x.h"
#include "../snes9x/apu.h"
#include "../snes9x/soundux.h"

bool8 S9xwSPCDump (const char *filename, uint8 mute)
{
	HANDLE hFile;
	DWORD WriteByte;
	char SPCFileStr[] = "SNES-SPC700 Sound File Data 0.10";

	S9xSetSoundMute (TRUE);
	
	hFile = CreateFile(filename, GENERIC_WRITE, 0, 0, CREATE_ALWAYS, FILE_ATTRIBUTE_NORMAL, NULL);
	if (hFile == INVALID_HANDLE_VALUE) {
		if(!mute)
			S9xSetSoundMute (FALSE);
		return (FALSE);
	}
	SetFilePointer(hFile, 0, 0, FILE_BEGIN);

	if (!WriteFile(hFile, (LPCVOID)SPCFileStr, (DWORD)lstrlen(SPCFileStr), &WriteByte, NULL) ||
	SetFilePointer(hFile, 37, 0, FILE_BEGIN) != 37 ||
	!WriteFile(hFile, (LPCVOID)&APURegisters.PC, 2, &WriteByte, NULL) ||
	!WriteFile(hFile, (LPCVOID)&APURegisters.YA.B.A, 1, &WriteByte, NULL) ||
	!WriteFile(hFile, (LPCVOID)&APURegisters.X, 1, &WriteByte, NULL) ||
	!WriteFile(hFile, (LPCVOID)&APURegisters.YA.B.Y, 1, &WriteByte, NULL) ||
	!WriteFile(hFile, (LPCVOID)&APURegisters.P, 1, &WriteByte, NULL) ||
	!WriteFile(hFile, (LPCVOID)&APURegisters.S, 1, &WriteByte, NULL) ||
	SetFilePointer(hFile, 256, 0, FILE_BEGIN) != 256 ||
	!WriteFile(hFile, (LPCVOID)IAPU.RAM, 0x10000, &WriteByte, NULL) ||
	!WriteFile(hFile, (LPCVOID)APU.DSP, 192, &WriteByte, NULL) ||
	!WriteFile(hFile, (LPCVOID)APU.ExtraRAM, 64, &WriteByte, NULL) ||
	!CloseHandle(hFile))
	{
	if(!mute)
		S9xSetSoundMute (FALSE);
	return (FALSE);
	}
	if(!mute)
	    S9xSetSoundMute (FALSE);
    return (TRUE);
}
